OpenCV: cv::DualTVL1OpticalFlow Class Reference

| OpenCV 3.4.2 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | List of all members
cv::DualTVL1OpticalFlow Class Referenceabstract
Video Analysis » Object Tracking

"Dual TV L1" Optical Flow Algorithm. More...

`#include "tracking.hpp"`

Inheritance diagram for cv::DualTVL1OpticalFlow:

## Public Member Functions
virtual double | getEpsilon () const =0
| Stopping criterion threshold used in the numerical scheme, which is a trade-off between precision and running time. More...
virtual double | getGamma () const =0
| coefficient for additional illumination variation term More...
virtual int | getInnerIterations () const =0
| Inner iterations (between outlier filtering) used in the numerical scheme. More...
virtual double | getLambda () const =0
| Weight parameter for the data term, attachment parameter. More...
virtual int | getMedianFiltering () const =0
| Median filter kernel size (1 = no filter) (3 or 5) More...
virtual int | getOuterIterations () const =0
| Outer iterations (number of inner loops) used in the numerical scheme. More...
virtual int | getScalesNumber () const =0
| Number of scales used to create the pyramid of images. More...
virtual double | getScaleStep () const =0
| Step between scales (<1) More...
virtual double | getTau () const =0
| Time step of the numerical scheme. More...
virtual double | getTheta () const =0
| Weight parameter for (u - v)^2, tightness parameter. More...
virtual bool | getUseInitialFlow () const =0
| Use initial flow. More...
virtual int | getWarpingsNumber () const =0
| Number of warpings per scale. More...
virtual void | setEpsilon (double val)=0
| Stopping criterion threshold used in the numerical scheme, which is a trade-off between precision and running time. More...
virtual void | setGamma (double val)=0
| coefficient for additional illumination variation term More...
virtual void | setInnerIterations (int val)=0
| Inner iterations (between outlier filtering) used in the numerical scheme. More...
virtual void | setLambda (double val)=0
| Weight parameter for the data term, attachment parameter. More...
virtual void | setMedianFiltering (int val)=0
| Median filter kernel size (1 = no filter) (3 or 5) More...
virtual void | setOuterIterations (int val)=0
| Outer iterations (number of inner loops) used in the numerical scheme. More...
virtual void | setScalesNumber (int val)=0
| Number of scales used to create the pyramid of images. More...
virtual void | setScaleStep (double val)=0
| Step between scales (<1) More...
virtual void | setTau (double val)=0
| Time step of the numerical scheme. More...
virtual void | setTheta (double val)=0
| Weight parameter for (u - v)^2, tightness parameter. More...
virtual void | setUseInitialFlow (bool val)=0
| Use initial flow. More...
virtual void | setWarpingsNumber (int val)=0
| Number of warpings per scale. More...
Public Member Functions inherited from cv::DenseOpticalFlow
virtual void | calc (InputArray I0, InputArray I1, InputOutputArray flow)=0
| Calculates an optical flow. More...
virtual void | collectGarbage ()=0
| Releases all inner buffers. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< DualTVL1OpticalFlow > | create (double tau=0.25, double lambda=0.15, double theta=0.3, int nscales=5, int warps=5, double epsilon=0.01, int innnerIterations=30, int outerIterations=10, double scaleStep=0.8, double gamma=0.0, int medianFiltering=5, bool useInitialFlow=false)
| Creates instance of cv::DualTVL1OpticalFlow. More...
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

"Dual TV L1" Optical Flow Algorithm.

The class implements the "Dual TV L1" optical flow algorithm described in [102] and [80] . Here are important members of the class that control the algorithm, which you can set after constructing the class instance:

- member double tau Time step of the numerical scheme.
- member double lambda Weight parameter for the data term, attachment parameter. This is the most relevant parameter, which determines the smoothness of the output. The smaller this parameter is, the smoother the solutions we obtain. It depends on the range of motions of the images, so its value should be adapted to each image sequence.
- member double theta Weight parameter for (u - v)\^2, tightness parameter. It serves as a link between the attachment and the regularization terms. In theory, it should have a small value in order to maintain both parts in correspondence. The method is stable for a large range of values of this parameter.
- member int nscales Number of scales used to create the pyramid of images.
- member int warps Number of warpings per scale. Represents the number of times that I1(x+u0) and grad( I1(x+u0) ) are computed per scale. This is a parameter that assures the stability of the method. It also affects the running time, so it is a compromise between speed and accuracy.
- member double epsilon Stopping criterion threshold used in the numerical scheme, which is a trade-off between precision and running time. A small value will yield more accurate solutions at the expense of a slower convergence.
- member int iterations Stopping criterion iterations number used in the numerical scheme.

C. Zach, T. Pock and H. Bischof, "A Duality Based Approach for Realtime TV-L1 Optical Flow". Javier Sanchez, Enric Meinhardt-Llopis and Gabriele Facciolo. "TV-L1 Optical Flow Estimation".

## Member Function Documentation

## ◆ create()

static Ptr<DualTVL1OpticalFlow> cv::DualTVL1OpticalFlow::create | ( | double | tau = `0.25`,
|  | double | lambda = `0.15`,
|  | double | theta = `0.3`,
|  | int | nscales = `5`,
|  | int | warps = `5`,
|  | double | epsilon = `0.01`,
|  | int | innnerIterations = `30`,
|  | int | outerIterations = `10`,
|  | double | scaleStep = `0.8`,
|  | double | gamma = `0.0`,
|  | int | medianFiltering = `5`,
|  | bool | useInitialFlow = `false`
| ) |  |
| static

Creates instance of cv::DualTVL1OpticalFlow.

## ◆ getEpsilon()

virtual double cv::DualTVL1OpticalFlow::getEpsilon | ( |  | ) | const
| pure virtual

Stopping criterion threshold used in the numerical scheme, which is a trade-off between precision and running time.

See also
  setEpsilon

## ◆ getGamma()

virtual double cv::DualTVL1OpticalFlow::getGamma | ( |  | ) | const
| pure virtual

coefficient for additional illumination variation term

See also
  setGamma

## ◆ getInnerIterations()

virtual int cv::DualTVL1OpticalFlow::getInnerIterations | ( |  | ) | const
| pure virtual

Inner iterations (between outlier filtering) used in the numerical scheme.

See also
  setInnerIterations

## ◆ getLambda()

virtual double cv::DualTVL1OpticalFlow::getLambda | ( |  | ) | const
| pure virtual

Weight parameter for the data term, attachment parameter.

See also
  setLambda

## ◆ getMedianFiltering()

virtual int cv::DualTVL1OpticalFlow::getMedianFiltering | ( |  | ) | const
| pure virtual

Median filter kernel size (1 = no filter) (3 or 5)

See also
  setMedianFiltering

## ◆ getOuterIterations()

virtual int cv::DualTVL1OpticalFlow::getOuterIterations | ( |  | ) | const
| pure virtual

Outer iterations (number of inner loops) used in the numerical scheme.

See also
  setOuterIterations

## ◆ getScalesNumber()

virtual int cv::DualTVL1OpticalFlow::getScalesNumber | ( |  | ) | const
| pure virtual

Number of scales used to create the pyramid of images.

See also
  setScalesNumber

## ◆ getScaleStep()

virtual double cv::DualTVL1OpticalFlow::getScaleStep | ( |  | ) | const
| pure virtual

Step between scales (<1)

See also
  setScaleStep

## ◆ getTau()

virtual double cv::DualTVL1OpticalFlow::getTau | ( |  | ) | const
| pure virtual

Time step of the numerical scheme.

See also
  setTau

## ◆ getTheta()

virtual double cv::DualTVL1OpticalFlow::getTheta | ( |  | ) | const
| pure virtual

Weight parameter for (u - v)^2, tightness parameter.

See also
  setTheta

## ◆ getUseInitialFlow()

virtual bool cv::DualTVL1OpticalFlow::getUseInitialFlow | ( |  | ) | const
| pure virtual

Use initial flow.

See also
  setUseInitialFlow

## ◆ getWarpingsNumber()

virtual int cv::DualTVL1OpticalFlow::getWarpingsNumber | ( |  | ) | const
| pure virtual

Number of warpings per scale.

See also
  setWarpingsNumber

## ◆ setEpsilon()

virtual void cv::DualTVL1OpticalFlow::setEpsilon | ( | double | val | ) |
| pure virtual

Stopping criterion threshold used in the numerical scheme, which is a trade-off between precision and running time.

See also
  getEpsilon

## ◆ setGamma()

virtual void cv::DualTVL1OpticalFlow::setGamma | ( | double | val | ) |
| pure virtual

coefficient for additional illumination variation term

See also
  getGamma

## ◆ setInnerIterations()

virtual void cv::DualTVL1OpticalFlow::setInnerIterations | ( | int | val | ) |
| pure virtual

Inner iterations (between outlier filtering) used in the numerical scheme.

See also
  getInnerIterations

## ◆ setLambda()

virtual void cv::DualTVL1OpticalFlow::setLambda | ( | double | val | ) |
| pure virtual

Weight parameter for the data term, attachment parameter.

See also
  getLambda

## ◆ setMedianFiltering()

virtual void cv::DualTVL1OpticalFlow::setMedianFiltering | ( | int | val | ) |
| pure virtual

Median filter kernel size (1 = no filter) (3 or 5)

See also
  getMedianFiltering

## ◆ setOuterIterations()

virtual void cv::DualTVL1OpticalFlow::setOuterIterations | ( | int | val | ) |
| pure virtual

Outer iterations (number of inner loops) used in the numerical scheme.

See also
  getOuterIterations

## ◆ setScalesNumber()

virtual void cv::DualTVL1OpticalFlow::setScalesNumber | ( | int | val | ) |
| pure virtual

Number of scales used to create the pyramid of images.

See also
  getScalesNumber

## ◆ setScaleStep()

virtual void cv::DualTVL1OpticalFlow::setScaleStep | ( | double | val | ) |
| pure virtual

Step between scales (<1)

See also
  getScaleStep

## ◆ setTau()

virtual void cv::DualTVL1OpticalFlow::setTau | ( | double | val | ) |
| pure virtual

Time step of the numerical scheme.

See also
  getTau

## ◆ setTheta()

virtual void cv::DualTVL1OpticalFlow::setTheta | ( | double | val | ) |
| pure virtual

Weight parameter for (u - v)^2, tightness parameter.

See also
  getTheta

## ◆ setUseInitialFlow()

virtual void cv::DualTVL1OpticalFlow::setUseInitialFlow | ( | bool | val | ) |
| pure virtual

Use initial flow.

See also
  getUseInitialFlow

## ◆ setWarpingsNumber()

virtual void cv::DualTVL1OpticalFlow::setWarpingsNumber | ( | int | val | ) |
| pure virtual

Number of warpings per scale.

See also
  getWarpingsNumber

The documentation for this class was generated from the following file:

- video/include/opencv2/video/tracking.hpp